#include "share.h"
#include <pkfuncs.h>

class THICeDeviceInfo:public TDebug
{
   private:
    PROCESSOR_INFO prinfo; 
	 
   public:
        string _prop_DiskName;
        THI_Event *_data_DiskName;
        
     HI_WORK_LOC(THICeDeviceInfo,_var_Processor)
     {
        if (KernelIoControl(IOCTL_PROCESSOR_INFORMATION,NULL,0,&prinfo,sizeof(PROCESSOR_INFO),0))
             CreateData(_Data,(string)prinfo.szProcessCore);   
      }
      
       HI_WORK_LOC(THICeDeviceInfo,_var_PrVendor)
     {
        if (KernelIoControl(IOCTL_PROCESSOR_INFORMATION,NULL,0,&prinfo,sizeof(PROCESSOR_INFO),0))
             CreateData(_Data,(string)prinfo.szVendor);   
      }
   
        HI_WORK_LOC(THICeDeviceInfo,_var_ClockSpeed)
     {
        if (KernelIoControl(IOCTL_PROCESSOR_INFORMATION,NULL,0,&prinfo,sizeof(PROCESSOR_INFO),0))
             CreateData(_Data,(int)prinfo.dwClockSpeed);   
      }
	          
     HI_WORK_LOC(THICeDeviceInfo,_var_OEM)
       {
                     wchar_t OEM[MAX_PATH] = {0};
          if(SystemParametersInfo(SPI_GETOEMINFO,MAX_PATH, OEM, 0))
                      CreateData(_Data,(string)OEM); 
       }
     
     HI_WORK_LOC(THICeDeviceInfo,_var_Platform) 
         { 
            wchar_t platform[MAX_PATH] = {0}; 
        if(SystemParametersInfo(SPI_GETPLATFORMTYPE,MAX_PATH,platform,0))
           CreateData(_Data,(string)platform); 
          } 

     HI_WORK_LOC(THICeDeviceInfo,_var_UUID);
                    
     HI_WORK_LOC(THICeDeviceInfo,_var_DiskFree)
     {
      string m = ReadString(_Data,_data_DiskName,_prop_DiskName);
          ULARGE_INTEGER free = {0}, total = {0};
         if(GetDiskFreeSpaceEx(PChar(m), &free, &total, NULL))
          { unsigned long fr=free.QuadPart>>20;          
           CreateData(_Data,(long int)fr);}       
     }
     
     HI_WORK_LOC(THICeDeviceInfo,_var_DiskTotal)
     {  
        string m = ReadString(_Data,_data_DiskName,_prop_DiskName);     
          ULARGE_INTEGER free = {0}, total = {0};
        if(GetDiskFreeSpaceEx(PChar(m), &free, &total, NULL))
          {unsigned long tt=total.QuadPart>>20;          
           CreateData(_Data,(long int)tt);}       
     }                       
};

///////////////////////////////////////////////////////////////////////

string ToHex(int Value,int Dig)
{
  HI_STRING k = _his("0123456789abcdef");
  HI_RSTRING buf[10];
  buf[9] = 0;
  int ind = 8;
  while( Value )
  {
     buf[ind--] = k[Value & 0xf];
     Value = Value >> 4;
  }
  while( ind &&(8 - ind < Dig) )
   buf[ind--] = _his('0');

  return string(&buf[ind+1]);
} 

void THICeDeviceInfo::_var_UUID(TData &_Data,USHORT Index)
{
               GUID myUUID;
             DWORD dwBytesReturned; 
      KernelIoControl(IOCTL_HAL_GET_UUID,NULL,0,&myUUID,sizeof (myUUID),&dwBytesReturned);
          string sp = L" ";
          string str = ToHex(myUUID.Data1,8);
          string d1,d2,d3;
             for(int x = 7; x>0; x=x-2)
                { d1+=str.Copy(x,2)+sp;}
            str = ToHex(myUUID.Data2,4);
              for(int i = 3; i>0; i=i-2)
                { d2+=str.Copy(i,2)+sp;}
            str = ToHex(myUUID.Data3,4);
              for(int j = 3; j>0; j=j-2)
                { d3+=str.Copy(j,2)+sp;}     
           string d40 = ToHex(myUUID.Data4[0],2);
           string d41 = ToHex(myUUID.Data4[1],2);
           string d42 = ToHex(myUUID.Data4[2],2);
           string d43 = ToHex(myUUID.Data4[3],2);
           string d44 = ToHex(myUUID.Data4[4],2);
           string d45 = ToHex(myUUID.Data4[5],2);
           string d46 = ToHex(myUUID.Data4[6],2);
           string d47 = ToHex(myUUID.Data4[7],2);
  CreateData(_Data,d1.Upper()+d2.Upper()+d3.Upper()+d40.Upper()+sp+d41.Upper()+sp+d42.Upper()+sp+d43.Upper()+sp+d44.Upper()+sp+d45.Upper()+sp+d46.Upper()+sp+d47.Upper());
}      